diff mbox

[v2,2/2] qemu-iotests: Snapshotting zero clusters

Message ID 1377851804-13614-3-git-send-email-mreitz@redhat.com
State New
Headers show

Commit Message

Max Reitz Aug. 30, 2013, 8:36 a.m. UTC
This test creates an image with unallocated zero clusters, then creates
a snapshot. Afterwards, there should be neither any errors nor leaks.

Signed-off-by: Max Reitz <mreitz@redhat.com>
---
 tests/qemu-iotests/062   | 64 ++++++++++++++++++++++++++++++++++++++++++++++++
 tests/qemu-iotests/group |  1 +
 2 files changed, 65 insertions(+)
 create mode 100755 tests/qemu-iotests/062

Comments

Eric Blake Aug. 30, 2013, 1:07 p.m. UTC | #1
On 08/30/2013 02:36 AM, Max Reitz wrote:
> This test creates an image with unallocated zero clusters, then creates
> a snapshot. Afterwards, there should be neither any errors nor leaks.
> 
> Signed-off-by: Max Reitz <mreitz@redhat.com>
> ---
>  tests/qemu-iotests/062   | 64 ++++++++++++++++++++++++++++++++++++++++++++++++
>  tests/qemu-iotests/group |  1 +
>  2 files changed, 65 insertions(+)
>  create mode 100755 tests/qemu-iotests/062

ACK.
Eric Blake Aug. 30, 2013, 1:08 p.m. UTC | #2
On 08/30/2013 07:07 AM, Eric Blake wrote:
> On 08/30/2013 02:36 AM, Max Reitz wrote:
>> This test creates an image with unallocated zero clusters, then creates
>> a snapshot. Afterwards, there should be neither any errors nor leaks.
>>
>> Signed-off-by: Max Reitz <mreitz@redhat.com>
>> ---
>>  tests/qemu-iotests/062   | 64 ++++++++++++++++++++++++++++++++++++++++++++++++
>>  tests/qemu-iotests/group |  1 +
>>  2 files changed, 65 insertions(+)
>>  create mode 100755 tests/qemu-iotests/062
> 
> ACK.

Sorry, I'm mixing list conventions.  That should be:

Reviewed-by: Eric Blake <eblake@redhat.com>
Eric Blake Aug. 30, 2013, 1:12 p.m. UTC | #3
On 08/30/2013 07:08 AM, Eric Blake wrote:
> On 08/30/2013 07:07 AM, Eric Blake wrote:
>> On 08/30/2013 02:36 AM, Max Reitz wrote:
>>> This test creates an image with unallocated zero clusters, then creates
>>> a snapshot. Afterwards, there should be neither any errors nor leaks.
>>>
>>> Signed-off-by: Max Reitz <mreitz@redhat.com>
>>> ---
>>>  tests/qemu-iotests/062   | 64 ++++++++++++++++++++++++++++++++++++++++++++++++
>>>  tests/qemu-iotests/group |  1 +
>>>  2 files changed, 65 insertions(+)
>>>  create mode 100755 tests/qemu-iotests/062
>>
>> ACK.
> 
> Sorry, I'm mixing list conventions.  That should be:
> 
> Reviewed-by: Eric Blake <eblake@redhat.com>

and just now, I notice the v3 patch that provides the expected output.
Serves me right for trying to review first thing in the morning before
breakfast.
diff mbox

Patch

diff --git a/tests/qemu-iotests/062 b/tests/qemu-iotests/062
new file mode 100755
index 0000000..0511246
--- /dev/null
+++ b/tests/qemu-iotests/062
@@ -0,0 +1,64 @@ 
+#!/bin/bash
+#
+# Test case for snapshotting images with unallocated zero clusters in
+# qcow2
+#
+# Copyright (C) 2013 Red Hat, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+# creator
+owner=mreitz@redhat.com
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+
+_cleanup()
+{
+	_cleanup_test_img
+}
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+
+# This tests qocw2-specific low-level functionality
+_supported_fmt qcow2
+_supported_proto generic
+_supported_os Linux
+
+IMGOPTS="compat=1.1"
+IMG_SIZE=64M
+
+echo
+echo "=== Testing snapshotting an image with zero clusters ==="
+echo
+_make_test_img $IMG_SIZE
+# Write some zero clusters
+$QEMU_IO -c "write -z 0 256k" "$TEST_IMG" | _filter_qemu_io
+# Create a snapshot
+$QEMU_IMG snapshot -c foo "$TEST_IMG"
+# Check the image (there shouldn't be any errors or leaks)
+_check_test_img
+
+# success, all done
+echo "*** done"
+rm -f $seq.full
+status=0
diff --git a/tests/qemu-iotests/group b/tests/qemu-iotests/group
index 43c05d6..de53b9e 100644
--- a/tests/qemu-iotests/group
+++ b/tests/qemu-iotests/group
@@ -64,3 +64,4 @@ 
 055 rw auto
 056 rw auto backing
 059 rw auto
+062 rw auto